commit:     92ead3e55a615419d54f59e11efa6a6d790f1fd2
Author:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
AuthorDate: Thu Jul 24 11:21:26 2025 +0000
Commit:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
CommitDate: Thu Jul 24 11:24:15 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=92ead3e5

mail-client/thunderbird: add 128.13.0

Signed-off-by: Joonas Niilola <juippis <AT> gentoo.org>

 mail-client/thunderbird/Manifest                   |   65 ++
 .../thunderbird/thunderbird-128.13.0.ebuild        | 1171 ++++++++++++++++++++
 2 files changed, 1236 insertions(+)

diff --git a/mail-client/thunderbird/Manifest b/mail-client/thunderbird/Manifest
index aa4d276984f2..cbdf4099bbf0 100644
--- a/mail-client/thunderbird/Manifest
+++ b/mail-client/thunderbird/Manifest
@@ -198,6 +198,71 @@ DIST thunderbird-128.12.0esr-vi.xpi 792411 BLAKE2B 
108e599d8ff42dbee45b32312ec14
 DIST thunderbird-128.12.0esr-zh-CN.xpi 792812 BLAKE2B 
a5a864850dceb064067707b9f1c524f09a134da0035e6a208d97bbeeec87969c6333af76bf2f33b0fc35d01a726aa9fc8510be3d0bb4fe84f85f725d222f7fdf
 SHA512 
d9aa626471b9200964a79e856a79d9c4401108f0c4dddba57389dbf8a3633e0b19434be7cb85a5b80161fc55fc1db896ab0115fd6c4aae70adfbd557a21b7b39
 DIST thunderbird-128.12.0esr-zh-TW.xpi 796025 BLAKE2B 
95f74f1197ed07e5cc20e52c520b83c3d5d7516f5a57969f6dc893e7ab8500ef4da113db0130c5676c864dac3a8789ed690de02e3a46e11b93167b1955d1dff1
 SHA512 
77cc8c1dbc868da4f371197a8056047d1b45479710f712b4f480e1842a905f17d0a44ce1da2244f15527a2b35ca0d297362cc8672ed880a9168dff67975e26aa
 DIST thunderbird-128.12.0esr.source.tar.xz 681085772 BLAKE2B 
24cda7e6c5920b3c2c4c9a5edfc39568b45fc7e5b0779f4bedd2774b03b8b8d84939cc43f0ae581f4bf953ffd080632154e0fa2158238da4943d910928c0126d
 SHA512 
4566ae8347e959612a288524753416f5b730757f10a067b6eb11139055cc1fc5d63d49636e798e9b77588896c8dbc0f2acc189ebd29d95a5166e7bc8f2c35e30
+DIST thunderbird-128.13.0esr-af.xpi 534911 BLAKE2B 
3b167ab88316ca54c392f000cb49a0e8f69d5e84ffbd4586148a8350af21ec59302d6e8c310a067f08dbb1462f90e801f1a99481c23508e1c9c89d143ceb8ba0
 SHA512 
4ab4dc6f624f98460d5a135aed856ad3b6f49dd6f52359c5ea5e76a88f2cff3cebc07ce49e12948451ff1b5c5e6d2e7fa702c8aefa8bd61421e83b2d4be95a74
+DIST thunderbird-128.13.0esr-ar.xpi 686456 BLAKE2B 
e67bef5615435f6985bdd56a5b748a7684b00d65a74291c6c43e101df614ccd12b691b8f479ded87330557043cb9053a9cdba9f0cc57e2d3f488ed530b9ddafd
 SHA512 
7afe13fab73643179700526c76d078d3241b5fe4606f3321717eaaa84344d2661bef5e52ce3f5d146e01f32f51f219988c324bd9c986f57ffdd7912a251ffbf6
+DIST thunderbird-128.13.0esr-ast.xpi 574780 BLAKE2B 
e00eea3465fe1247ec0720b8ab9186175d6660eab14a2697c635fb20d896da97c3d5eee9e3a86b27315d4c86473817ded371c5ee93d20fd8ff9c125b194caf96
 SHA512 
71e6f51194017d90636356951c007b7215ed109b3f35fd4fde2ccd2a281666bfd3f01bc49ee780fc8b3ac251479a7f1a1a225bdb6dedf6024ef29841d1e7ff59
+DIST thunderbird-128.13.0esr-be.xpi 781772 BLAKE2B 
19af8e999be797ce072f9249973016aee7f1ce63db6f64a214a8acf5b079ddc41eca0c3a392e2e122f40259395bab7afaa296cfd0cce60495eac0f5b0fd4aa6f
 SHA512 
88b59fcd0effacea827a457ce212d502fbbe38759aeb679f3d2bddb482cfcfd70cb0667998ed9fc80276a5aa628ef99b1fb9e5d44c341c017ada11a2aa7c8265
+DIST thunderbird-128.13.0esr-bg.xpi 813952 BLAKE2B 
2520010af33f955009220340e0c2a08913253da7434b3df7ec10afa32eaeaf21a6ab2bba465da457d21c660a7e60c65d2bff19dad0079e503b1aef2b4556e184
 SHA512 
58be1abae8760598b4d93c5f86490645fcb3366edd6590b91adfd6c807b652c04cd0b3e5845637ecec9cf846864234b68cb56279ac5519fc9382f51806b0d0d9
+DIST thunderbird-128.13.0esr-br.xpi 650139 BLAKE2B 
b843380d5a5eeb233372685df8d7b7ee58ac1bfd4d8bd19d27e2214bf44253f19d9fc05d197ed01be7be7da9cf5a0826105ac0bffbcca676d8b5483679ad9d0e
 SHA512 
5be97a10f5e4c0f828792641b4118d95e49158ae2096126a1e5e0d8551be417b5d49d018837fbc8200cf7a95ba57ba491b5e50978ae4624db7f8b59ca60c7f67
+DIST thunderbird-128.13.0esr-ca.xpi 704670 BLAKE2B 
644e87a956215d25ecda9af5f60c78f43b05cac12294b881a56bf8d2e2ab9752dbc82ac95ad1a52439dc3f7ac113ca293b6d638d5a9a771eeb4757bf53480e8f
 SHA512 
b913b5206cffe58cb06e0501abe4c0e2e108ce213102c84ad10814a020ab080f21347d08c450671cfef1e858b278a833204eeb29c926816cbd2ca7bebcc4a5f5
+DIST thunderbird-128.13.0esr-cak.xpi 669085 BLAKE2B 
4ec69f0b1f24e99fce20eee357b10c11e0497dcef78f384a2cc858c8ba943d25561016a3310817e0ca3a1bd9dfb885ff6259e7e610f8638e8281c8191b346b6e
 SHA512 
071dd02152c3efec5b44da92098aa5598bfd2bd4b114aa465899314fc74a79b725498907f31c1db6355f81ebca9316d2d64b1aff0a26ea0839377556c5e88e6c
+DIST thunderbird-128.13.0esr-cs.xpi 791811 BLAKE2B 
733dfe0b047b2ba9d2283ee24f46e03dec583aa72bd30d71e43b66c5a3a9b63e151f69dfa301ab62105d861d42faa64d2b757ba91dcc8b920daa8e400132ba8a
 SHA512 
846d6e0b5639a9afe7ec2268cf2043497afa46c182f36ee274e05ad26a0945c19ef61f2efaf3c786ac130dd18554dfee450511d7eebd5e8d40288eec575cb768
+DIST thunderbird-128.13.0esr-cy.xpi 755456 BLAKE2B 
a161b3143cb76264fe6541af5b390f50c0e2f9c825921961e001413cd20914cb4f994a23664dab36550b86406e0e47a8cfb06d9f5cfbb71da29e83a74354ccb9
 SHA512 
f85e61bc3fc3c7fb0ef6a887b189c2f6f87ff5bf48962dcfae754de9ddf11f5d61aefc0f752107d125745865571f2725bbb84ce018405915caa43f57392b7093
+DIST thunderbird-128.13.0esr-da.xpi 742381 BLAKE2B 
3ce247eba3688941eaea3c3fef5ee19912aaf0aed8cffc9ce9c95d81828b95ae493c13955bee40e4dcd6e75199c524cac47aa614e13cd5ade0701291329848d1
 SHA512 
89e094c309cbd09575af269f83e625cdd4dc95f46f279030284992e22851fa30cb15c65ce3f51ec724e66313c3f92922f02b5e46af20fa99949cd71abdb9d6e5
+DIST thunderbird-128.13.0esr-de.xpi 773218 BLAKE2B 
63f7f89b6240b3edea46aae6b16c7670d68c567f69d606a196e6779cdee829e234164dece277c41be2b55841afc3767638a20b7a6676b88533d5ec4b3b00dc90
 SHA512 
a479f274937635e526bc77cc82a7bf8bdbac8caf7636786779cf5812de36b91d0a086be7e3215c47b06592f56224e1eaacc698c236a7d1a7c39b25526b57cf76
+DIST thunderbird-128.13.0esr-dsb.xpi 789460 BLAKE2B 
5f32efa5e8fb7d5750baffc1aaa3bc79b6a48125916bce4b3b1c1aafbe5d7132bce6e72e6020506d52a2793821ebc85e88afa56f4e12bc6d84b72f1e0cce6a4b
 SHA512 
2d00f5710d9138be6d213fdf1d619a0e82880ec97b305f5fd302a465199876a41618d16275c49eb53f1c99200011bab39ae5ecaa8628f1019451e6c52ef54f1e
+DIST thunderbird-128.13.0esr-el.xpi 894806 BLAKE2B 
0b20c5547f28558781ce9a125122f9ea347bb2381bb4931994ddfb44cea82bdc558c05ec30a1734b6b437b7e718fa84b553c90a54555385c99c885266f61f738
 SHA512 
7b0dd16a8a5b5d260fe14c2f3fa3edef793e042d39ad56904c6c84757b04c3b709b1d14c1bfcad1888aed2569148f2872bca187bf463622d0aab0782a09707df
+DIST thunderbird-128.13.0esr-en-CA.xpi 705284 BLAKE2B 
a7ea9ffe006cfd30cd8422a877a06401e0182d2a39ada8653ab5eaec927446199ae87cdc91f5e0ed1e11c8b8059a163d346c867ed657902f569e358d44177c38
 SHA512 
c97b55923a86ea8a414dd42fe044d1df9e89aefa0c696a5c5e672986929ddeb1753bddcec91fb4c77a6b55a2d064120d95cd8cd85393d38f4308e7acf8f19507
+DIST thunderbird-128.13.0esr-en-GB.xpi 706748 BLAKE2B 
ed44e8e07d00331e1fefaff81a7fe89dffe986adbd8def39dcd9372064b065822492f507f3375f029e879fbcea2fa2680517ae57953a9a64a39df1c1e37d1200
 SHA512 
304dc2289b8e54ef095828f63e1e7d80845acb82d62368e115e23b60552d7e9a37c3bb1caeb4c19d63a1f04a42d24cfa25a3607ef33f9a6aba45a574e1e78ec1
+DIST thunderbird-128.13.0esr-es-AR.xpi 762734 BLAKE2B 
218b185f21446c85ec8065801c9d3ff9c30b4e397b1708ea30c8e11d3c5248e97ddaadeacb00679a07af2b90446c090df00b9c5cd82d0fe1afea1c08932326c6
 SHA512 
862dcb8f3ba9797967b5f94b1da256d78d1f4b88ad205a31898b1a1edbbbced61de294f5712d0b5c5c94d57f09f443514b2196d8eb28cd1556fe1b847ae8d702
+DIST thunderbird-128.13.0esr-es-ES.xpi 764644 BLAKE2B 
a008dc752b8d99884da66a5fab05b80b3c69740dc16112d69aaa06fafa85d8f9b935365d9346108abb90c0d2181b952544b0469f0aa97655ec0ed7f2638e7539
 SHA512 
a7620861aaaddb8a3ccb57dca431571c1b3d650480738f1f627798a8cf9e0f5121139a218d464faef5fa8f08e679fd7bbda0884cb61e550609e3d8c869e6f7a3
+DIST thunderbird-128.13.0esr-es-MX.xpi 756899 BLAKE2B 
e233fff070e27a343dac1b2de3ccc6ea637c747d51693af696450064422e19d3a3a0658cf135b26ed2702362fe4d7cf558746dba7127cccee9ab4598c8fc715d
 SHA512 
f6ffd376ad63fa688b5d749bf647ae1254bb2c505c0627d7a9d85f933436d034b07dff1300f0073ffea3dcdc7fe45961af30a0f39ea33ed5cf67b32a069fe97a
+DIST thunderbird-128.13.0esr-et.xpi 704033 BLAKE2B 
c152322958ece455eb75b10a945f856fdb0ab3541e519f54c3dc848595b24c33d1d1346c119ca0c8811b959823622ce59dda628845ed434ab97756c73e91c79e
 SHA512 
dd876a0772c7122f9940cd20c86e619b76e7e9ba27cb6f70a2cb57ee5eeb87ac20691cb6e84e54823d3cda12c93c4d11b2dd7291df2b15b21e4887bb8e33448a
+DIST thunderbird-128.13.0esr-eu.xpi 739567 BLAKE2B 
56994e27253493eaf8f0760306f4328611c107190fa7ebc86330a7080c981bf7b42311a35b94a5c23f24ff775c613fc66a9b003fc5f86643ba29f6a46b763770
 SHA512 
2910e5839bd699c2dea2851b193ae9304ee2bba8f36d0ecdc3f606e185562a0a0a45665f022a459b5312fa36e3b130443df07b34bc6f68be5ff6602df948cded
+DIST thunderbird-128.13.0esr-fi.xpi 735962 BLAKE2B 
4bcad9b8c96872590c1be79b83c49789f3b6cb3dfd35b1ada678dfe6cff4b23fc26b9efba4d7d8a9a0edc91b6639a5a848d0945b9326e0bcc73f6dc410b97328
 SHA512 
d84a053773654211532f42b7db23027a40bcb696d98c02feeafa4947c1ad6ca1b60a43bb50c7dda46b74c3f9967704a93f34ea5e2160b9df1d41530fac6a53fb
+DIST thunderbird-128.13.0esr-fr.xpi 776996 BLAKE2B 
3a89678a3fb909d2fbe8ca202b90ebf418c37476d8205c06799aa2b3cbf9a2bd03102ed4f42d8e3d4b7a87d6b60520e568493bca56e441506793e4a25eb409bc
 SHA512 
ea0411d77630f8ed6e4b1feb1fd1853bd20fda8eecbf8bddcb8fd53a0f71acdee3e90a4f8c812ad8aac0087204e24c31cfa365551d1813f6e19ef2795c449d18
+DIST thunderbird-128.13.0esr-fy-NL.xpi 758199 BLAKE2B 
ef4081178bf9fe8b25884acf949f8ecb7d2945075cc71aa1c6ec91e98b9fe9b061c3aca2a224b2eddde7e640fdf7095fbaa8eb3fe3b239025ee679f976246a4d
 SHA512 
a95cb01cf8f57884b3a7f49721513456022fa72f695d506770a4415ad4164c41131c0802b256893954547ecaf11ffbc709ff9e5bea4e781aad374901c834d363
+DIST thunderbird-128.13.0esr-ga-IE.xpi 614301 BLAKE2B 
c3376a6ba93a6f5568cbf2941855461c7eb162920e10b9175e52c631f7ec32f1cf3ecf8f2ebda3fa819e2bbdf214940115bacf6aa4d13b42ac7cb28728ee91a9
 SHA512 
9eadecb7745c719ca88ff68d3a32f96acbc1b2a74c8032dd97840af990e26fe1080a4bfd9268bf81cb0804e322c8370c0c64d255725c4941d8ab95881c99c29b
+DIST thunderbird-128.13.0esr-gd.xpi 723343 BLAKE2B 
c5b4e8e26fb26dc01f7fa4e0fa0dd0ab8bd57f80ba179cc3c559f768dd0d56209d7977b21999ff58d06f87240d84ba44c8b8cce1e0b0737f765b8bff2ce634a8
 SHA512 
e367a0ef7e390475f36a535ed9cbc25b868c02ef707718c4c08bd1d94c5df7a2e627e83f29ceef63ab1db5f418526357b02178480fed62c16cd2915d09cec32c
+DIST thunderbird-128.13.0esr-gl.xpi 738608 BLAKE2B 
a436242048436b51b88a4ffc59780ba1c83720813ea59207dad23d053c1c3ceb29e9c137d32ce92eeeaf24f66ae85dde31654b1d7068bc1e006970a98459ae60
 SHA512 
1e3893951bb3d637c5211bc5ec932a602ae5958759d6da33ad142e78f16792b8cf7d08d6d5f65a5d862d01a0ddc459526b325dba426cbe089be8eb6c09810842
+DIST thunderbird-128.13.0esr-he.xpi 697001 BLAKE2B 
95394d90ad5471e4a460f817459f2f64e9bc223dcd8371f4a3a6800ac020a5d808e32ea10cea8bd9432245c709ad6156bfe64925a857372681d53ce6075a5676
 SHA512 
7be3e1342547f75a32c42459da91a63550da3791b15555df67231de20d7e5912a999614057e00f0834691c21de27fedde06e2d6c011a632c56d7c82d1f5494d6
+DIST thunderbird-128.13.0esr-hr.xpi 724917 BLAKE2B 
c2b90a7efc5a90016054a2a6448e77be42544a0135a830f57415ceffeef91aad177c04e951261c6d8075e0ac5d060bb9ad13adaa0da383da2cb1c0f590b55c01
 SHA512 
aa84c29baf184658d58f42830e0392c1d208777f45adfafb93f8f7f2701c2c12a9ffd31ab47c1394f55e4de304c394000d79e0b5e8dbab22c89f0cc308001059
+DIST thunderbird-128.13.0esr-hsb.xpi 785988 BLAKE2B 
89ea1ed618a167efb8452897bee6bd0723728918923c04b8ffb5b4bf4bbdef93627fd4b51eaf33af6ab0c6199d1cd363f22cb0ec8b25b7824630dc1c5303941e
 SHA512 
c0f3045633acc3362e8abacfbdb3f5aa32ea12bb330ef99e27472c340f7fc99a791bee4d944b0e6a0a31af36f77d2b0b3256402cca6bf11e9a9c2e681e85cf8f
+DIST thunderbird-128.13.0esr-hu.xpi 789527 BLAKE2B 
1544fac2fda3c37a9676e6abeb0ed27550b8f3532b9e4c9219d1acb87cdf55c6433977f91b5b907bd30fda91a59f1753b3a3030a5be8a8bdd038babe9959be73
 SHA512 
e68b417c94d26a5fe9920ec4a3573096f580ee8d1933f551fd89f23eacb62fa3b65070bb181f5b3d9e14461acc9698f096652392a9ecd3994f3b959143a54603
+DIST thunderbird-128.13.0esr-id.xpi 721047 BLAKE2B 
16304f1c74493271ae2afd5c783d524476ee8882213bfd00bfee9e3d717679232ee6917785769cd842659dd44144afecf9560411b8544418e872f01457f25ad0
 SHA512 
c3471a021bf246dc7e7f3ea9645f598849d79dae7880efbb8f2a29db2e911652f50a70a75c780ce27af919dc718f403f16a711c26e28a6815a4aeed9adaec0c0
+DIST thunderbird-128.13.0esr-is.xpi 754158 BLAKE2B 
3d1bd3a02d291254d98a5336615eaa5d2192fbe08a2d96e1488206b1bb0befbe0cc93014d442dce3b75a6d5bcecd0e5f615bc9d1920254212d1a687d7e9c6a63
 SHA512 
08494d6b90ff85ac82555d1aba133a2214c0971bef465231f2fdbda1f2c4121f8b1ad33c79da695581616e9125ab4dbcb0078af48b17f23c0a22d3219044ef25
+DIST thunderbird-128.13.0esr-it.xpi 753781 BLAKE2B 
be94fa47e7f56491a8105bd410c448bd887ac183b796a2d97c73065c748cc86e16af4deccbd5303dc9cb9501e860d1a2b351e2db1d024343e3d494c7bc29c802
 SHA512 
bbb502d221f911acd80d3f5f2d1be29f03d401a4465233782426d3dba2b21c56af06c169bcda5bb3f2d26d9b59137155db0961f600091c31e7e565567dab2814
+DIST thunderbird-128.13.0esr-ja.xpi 824751 BLAKE2B 
2ef04fc74d3c6e6c13412ca801e78fb202d49ba89525ffdd6c3467ebd6e44e0cdf4c491f61844ee7ee0365586574b8d5cc207c452cee189472a0002b2b978a2d
 SHA512 
df67b9e2690f3065e72799d04b7240896cacb182eba7ded7931411d447a41244184b6fb5636c0d13259301a8a499ea89428fbaefeeb1d611cffbff808d5074ba
+DIST thunderbird-128.13.0esr-ka.xpi 832695 BLAKE2B 
af78abbdfff0cefd59f2198985a5bc274f876ba4dada1325b50d500a0297290051c083e5816be31c91fdde259320c43d28f7ec58b342e5f71296355e9d67fbdf
 SHA512 
980de7ad361e8a2775a9f70a9adf619d0ef3db9853427669db6b22b7a06ae5358be297a5f99a49e8fb28a94a39fdbb2a9c6aba102e889da2b7ca09e5218744d5
+DIST thunderbird-128.13.0esr-kab.xpi 732879 BLAKE2B 
707c3a20a963a23a313da846be183560b9e717b03fd19668646817840aa887491479dca17abe210140d6710faa5a31a07133102bb2a70ce65c372c39c2937365
 SHA512 
a78ec0e51ff393405217527a8d7dcd480e960f661043baa034ad8fedf512bd0c1a1295ecd69eaf63a3e42dfd008f5c3742324ba1203af58cb34f735ee204a709
+DIST thunderbird-128.13.0esr-kk.xpi 860569 BLAKE2B 
bc3c1a0ad8f461325ffa9848d2bd58ac8901ec8b1306466a785b9e72a0eb15b8fc35922d26eea7631dc760e69337fb7065bfd26b43f552135e7601e3bb4486a2
 SHA512 
d9cf3418583aac5727cc0cbb986d3720a423cccec1c1814028c3dd23b652994088fceed7b6459e763bf0324840538c338d628d7379d15510ca476621b6c65b3d
+DIST thunderbird-128.13.0esr-ko.xpi 792673 BLAKE2B 
b04de05e658a1ad85ac6fd38d18b6caf319555bef5bdb5821a8d0b58f3e40428c34461fb1d8ce0e2dbaa0e538b151a2b9d7a302d3feae821aaab144d3ecf4b0d
 SHA512 
7d6487d0fa83f4ec700118eb1bc788c21e0e6c48cc7502239b52ce5e7a7ca4d1d380f44875c0c340fe510709107aa046bbbfebb8ad68a34df4d3367120b0af85
+DIST thunderbird-128.13.0esr-lt.xpi 696746 BLAKE2B 
b4c77ae924dcfa58a8332c5bb6c57d787a22c44f0b0dcbb9498a1328ea8229047b6e0442b9c6481bf227764b17c6378a15babdf128aabd5affa963f2f5c406a0
 SHA512 
12f68d3586cafa19de5cedb16540eaf2337a95901d7df594b9f4814941b9ed21efa00807e57563caa98344b207f87c9bfc9365dca541525cd0b746c2c95d2d7e
+DIST thunderbird-128.13.0esr-lv.xpi 626199 BLAKE2B 
9a710cc5fda24206c7e056f69394a603d654aba71cbfe5d1e4eee2761be8a689e079f035531ccdb8ed9a4513478c6a9f55a99b254bb8c9171228e17a1bfb4603
 SHA512 
6e5387a4760768a24319bd0298d049977d62a927cc545f2277b006eb29791157da5f3735b0ff645c8ca05e08aca3f29f9c0f84d9117dfa6ce26eda4f656b8d58
+DIST thunderbird-128.13.0esr-ms.xpi 586638 BLAKE2B 
d0082ad1f810214e04b9e0b114f631eac913210a94fbc49e9ba2d77f8e9e8e944631d5e5958fccc602b362c74f2dcb7001e100ce9c129b83995b665a8e7a8b46
 SHA512 
79bc4a585da66ea176f1eb2d57a696c4787067b5dafa81a383d06c8273d9d564e2fb9bc179f4e13ea245b98b5693c6a3dc5218250c01a39d4625111301a686e7
+DIST thunderbird-128.13.0esr-nb-NO.xpi 724067 BLAKE2B 
e9c21052b47aa6febf69b3ab50380eb51700388666e185c55ec7fdfa57643fb2a62050a7e3f9788ef305281a257f1d8f21be909cacae90cf10038528da86c56a
 SHA512 
9535bde86c900ea5dd1b45df62d68f36988ba830962befbeefe8fedfb2650fd28070c58ea136cc8cbbaf206219511b4b0301cd741f6f29104a21ce31b4325b1f
+DIST thunderbird-128.13.0esr-nl.xpi 748465 BLAKE2B 
962a26205e4c05649ad9d32e92374103c1b58023db97f9d9079733750d4ebf0fbe4713fef7a8f054e79dafcba4c7f6dd5e421caa564549a9231c98c698cff864
 SHA512 
c950ef67608001d14ae6e713efcd880e370b5e9706fdd44497619f0a3346b6e7037c2b83247c4eac5085df13d99f162844909af2512179bf179c586181491bea
+DIST thunderbird-128.13.0esr-nn-NO.xpi 727686 BLAKE2B 
35f4fea885007c46084419e25c282a52e40d1cf0f9b0d38d3201f7dded530a4400703288583b4dd3d84bba5440bf1355e2d7c6c1c742e542284a2bcead524bef
 SHA512 
f07236dd615ae96162e4626d044c0d9e85bf82a61f6756aca83ecae592ecb820b815d4de222907399caab7f1ae54bf32041ba9c71a251d2db651016e1969f53a
+DIST thunderbird-128.13.0esr-pa-IN.xpi 687933 BLAKE2B 
8d42b12ab70981c967a4454bb96584ccc33edae37f0ea44281167a3b39af61af4b2551bb2c4849110d83b3a400207c088d8c33e40accd8c69ff26ccbf5354045
 SHA512 
7b761ea6004b317a79d0b74f576eed3f4d33f305ffb5befa81eeb5aa07842b7f978487144b88111db1a409e97be5ca433ac897316bb0affe254e4c3572ef6b99
+DIST thunderbird-128.13.0esr-pl.xpi 786473 BLAKE2B 
2ea26bc441302fc59f19a79831cea153d70474ca8d6ad488f30f19b45b8a0f553c1c21913ab3832e8812cc771bdf3607c267d7852d52e557658986b25b502863
 SHA512 
69bfeaeb55bca574bac223027175de167b503a4150feea1a7d47ec0a5f4d6178ba3e44e61f645c41524ed3cfcb13b7a5b194bddfc41069e3c5474b1ee0090458
+DIST thunderbird-128.13.0esr-pt-BR.xpi 757491 BLAKE2B 
8bff73e5870e7624d0876c6dcb783730ea34a5b428dfdfecaa4c60c199f5482d90f5fa2959a87a2d5408a2fc22f11ddd4f907e6783627ab3744960597d30fd97
 SHA512 
ce48217c4124e82aa363a24fb6ddfd106111e28dc4726f367a74bea457d81cef91cd91186ffe5fb0c38fd537952af5ecc9042dee85030166ea6a64a3a865b15c
+DIST thunderbird-128.13.0esr-pt-PT.xpi 751364 BLAKE2B 
5338d633ec1d5e5a265cc0de4638144ed435fec0b9ac4f53d64bd91f7156cb25052fc723369c6283cc398ddad5788a8c20c5c7037ca1e7ed13167cc8b4c9a192
 SHA512 
2b78610f186ca647a43ddce7f143a66f8ddaf50d96a17e2f78222135c49780850ea156002c588c004aca491b3b97fbe7ee3fe82be63cb9c1825920ca766919d8
+DIST thunderbird-128.13.0esr-rm.xpi 752552 BLAKE2B 
cdc51038d12f404d3c3422a6b93db26d3049259232cd2f6c9573d7575f466a78a21bf6b53f582dfa3552fde38bcbffbf79cd84bdc7313fcd386c0a1ec8b4fe07
 SHA512 
9563a191a777ff0b921a2495e6cd69f13fb3576b3aad85129f45e5c5204466cb9fe50773bf2620e097f0c92b41cf222714518ea50e699addb6e86896b798186c
+DIST thunderbird-128.13.0esr-ro.xpi 666540 BLAKE2B 
4dad697c7c21cb2806e69d95a66101ea50edaa0cc28481bbb0de47935bc6f158784c169f6d39f6a3d53dbd7e2fdf09969d26bb5465fb68fd938e499e2789e7ef
 SHA512 
e2dcf434444274baaee5206fa8488ff5bad4a16e7332401f1ad6afd9f4106dba167abd305aa76b27a320e46fb4685a61856273f8d569fac65afbc239630c967c
+DIST thunderbird-128.13.0esr-ru.xpi 877979 BLAKE2B 
9cc26a012606e73378ca55d98925193e7255ce026a3548e9312d3a8b2abbbd51e5f60079a7ea68a909eae44747172df5d878db25fea93bdf0f1afc508667dc0d
 SHA512 
b43f44a6ec804e76c2fbc1362382cec3fab541180ed0c724fb572c497b7b5c634673e37709960215134e37bbbd8ece8c27fbd4ebf00e40897a1558b6e22225ae
+DIST thunderbird-128.13.0esr-sk.xpi 791134 BLAKE2B 
cf0913ccb3e1ecc927c34c45df712d759c08d3548b618399eaa8a1f47a5b3cf75c92534e28128e5110866974be7b53c7423484e4d3f99e806d4b847b5fbd0dc2
 SHA512 
3972f6f0dba46dc9309ca29378dd7f2a451e280d2bbadb76428d9b6bf7a3c0c304ddfb99819141d8410dc13fa9a5a97c110ad7b2ad5cb6337adc2548afcd6acc
+DIST thunderbird-128.13.0esr-sl.xpi 752434 BLAKE2B 
11ccc9f38b6a5426073715b39ba4bc5cb2effac2aa38c1bce4296c19eb2eaf74cf9188eb0ad162c6e87aa19ca7975d52c2a68309e4587614a599a9d150d25925
 SHA512 
de7c8119492f87ddf191c40bf7e7797fd2cda0e7632f707d4f58120194eaaa91f374a147379d7531cf18a4c63158f97023f67ae833c5006e3ef3aa8e0318c31a
+DIST thunderbird-128.13.0esr-sq.xpi 774169 BLAKE2B 
a697f894539dbc95483627b3de8401b86d04283b81bdfa53c595dad2578429ad5d2846f9c3bff4f8c6e865d8a88e9e3ae2ed52fdbe7cf7d6a8c46d292f4cfa2d
 SHA512 
8f087426afc5f73f38e5eb2a8805c19e57c4c524c798f8ee0762e336ec938f1b8338a6c75fc7a6e0f23b760d0bb030687b4f67c08f0bf18dbfc46895f1f8f2c5
+DIST thunderbird-128.13.0esr-sr.xpi 766341 BLAKE2B 
5d5876cad146be81a9c4df2b4312da77193cd64000e9195bd91707975f0b54b84084d87512a4832a584ae7177552e7fe0e0c7cbb113fbb1f64f16d73dc471ef4
 SHA512 
e8d32598241b21791bb874a83bab241c91a81512d4e497f442ce0c65ef4b4f60458f8b6f2c4e651683c1e30661ac14fe11e2e24f0c46eb754a093db9f2a685c4
+DIST thunderbird-128.13.0esr-sv-SE.xpi 752309 BLAKE2B 
bc207d168e43dbea4eef5159e6ce4c35c22bf44f20234a667327c89ebfc25e8d8608f052deedfd1ceb715717f3210899f6f12ebefd8795d880c3df257e4c6982
 SHA512 
e83ccbf07432bce81e5d26d682fe6498f1477e15e06aa8f084dd2734d302ff23ac76886f5b8c331e5e8eabce711c5bdcea950d15356b266321a103f47586d6cd
+DIST thunderbird-128.13.0esr-th.xpi 849557 BLAKE2B 
693bef46b7ef8612f4751f4c8c45d509ff69df37e5283d5063d096c4bf8e6fed03f35fae27e1feffcd6f39b489334ecf1c0fa39c249e8e74e48016984d6655f4
 SHA512 
ae7d7e979a8aeefda14e3ffccaa1376b448dea06b40a6eb5c1e219ec61679c5855676dd57954f7c6ed614cd204fb53f05f1badcf60dabd43569c73d20aa32278
+DIST thunderbird-128.13.0esr-tr.xpi 764272 BLAKE2B 
21deb4f2ad6c786c33fa381d837ff0cb1ea7d0506b9604ba8ba12b0981064f7a39480a431ca4d460cba226ea1058567a26f192ff421069bbce5b219971d47f27
 SHA512 
d326734164a5ac5848bb504d50ba6e5c54dd37b48b8b4ad956801d13ace8bcf746dae0e84436c3bfe86e0073d5a3bebd6cf722bb2b85414a8e57d14160560e48
+DIST thunderbird-128.13.0esr-uk.xpi 866386 BLAKE2B 
b9d035637836384792774f5053b445b9339ffe5804d6856c5cbdea8ea2e72c05f848bcb5be44121cc0863f5d4b82828e4297a8db8f83ecfdce8d487127dc9f1f
 SHA512 
22afa2155e684a98ef50318191780ef98959628430503090090755e765bc1b7123b4283fec2e92718924053b6b6bd8d22f84fb04c92a2457f4a39fa21f9cbdc8
+DIST thunderbird-128.13.0esr-uz.xpi 589334 BLAKE2B 
d6092a913e5802f257b93df012e343f9c7832a8f3318f3045b7f153c06d8998d8f1e7d18756609c6eb81541430ca90d2722a7702163d2e3c68ae17827bb17a22
 SHA512 
277dea933af81dd39d063ff76c6114b525921e3df676cdd965ece5d6fb228571f61327a0733cbb617437eb201762ff2f8fa5d150184eabd784a26a5975ea128b
+DIST thunderbird-128.13.0esr-vi.xpi 792407 BLAKE2B 
2966a78c890a1b6b14ba9e6763a474cf6092e53ae35a30ee956b33177c76f4204c74491255e48cde28d502673d2b34f2a71f4793a10335f10a13639f7418ed2c
 SHA512 
82bc7e1afce844ab60066ae8b8c7ff638a93a954455eb93f76b1c77466a8aa890eddff28d94d198d278e11372a8cbeed37c55d4850b2f24af4b3a2e748c76369
+DIST thunderbird-128.13.0esr-zh-CN.xpi 792808 BLAKE2B 
b433ec5b64f235dd0d5f0c34116f44e9a6fd481962ada92b0b807dcb830864323a8f3f2c5804cc6e658821d5b15213aa285aa5b28dc11efa1edc46058da286ee
 SHA512 
34afa1e42c7e05ca23e10dd350a150aa8cc3b839eeffc2bbd7e2dd163a7610687c38c4f1d3d9e0143bd53f953cedc80a6333bbbf2ce62807efa111933720a94b
+DIST thunderbird-128.13.0esr-zh-TW.xpi 796021 BLAKE2B 
7a63e8930efaf5ebf1ea762e0f96f8be2320235ae8de56364c672e2f0dee5c05bcedee805aa0aef3f0ee4dcd52c175ba800fb23f83e2f02fcb10db9acabe604b
 SHA512 
971907381052bc777931843d3b73c8c8fad9c51234259759557225661e3ef6662549b5ce402cd83f523ea29990c58c1821774a8c66c26146da63b305ab1248e8
+DIST thunderbird-128.13.0esr.source.tar.xz 673842312 BLAKE2B 
797a13fabe9a2e7f7aa5c9000a092770d0afc48ae8d22a2d6fbd9f794a80bc7c88ad80b5adf8550851f9affc5de426cb58429da1e36860064b6792ae0da96168
 SHA512 
0439ff3bf8549c68778a2bf715da82b45a9e97c2ff4a8d06147d1b65c13031489a4126889a5a561484af385c428595f9d343fb6e266beeb923d4671665f2dbdc
 DIST thunderbird-139.0.2-af.xpi 316966 BLAKE2B 
af48fb7d139134ddc3eaa8a88e9aad7db3f07bcaa0fff6194a90d7cc7d7fc045b955cc1543730c2e09236153a8d4e4c0e6f0100edb1327b908ce3878ffbbabba
 SHA512 
988a9344de207b105e21ef9997bad0cc0c77defba62004da0017bce41abb9e3555e7d813413d86cf8852f98d900fe75c19b5e08b3937f64aaad409d583de2a3e
 DIST thunderbird-139.0.2-ar.xpi 435736 BLAKE2B 
f306f18bfc651efb265a73aedeccab0e63179b6323d5a04e867b88cdd426e61fc210691c60b8de0fcf2675150b86e0c294845fd3862ecee83372050223946c1c
 SHA512 
d161bba3aec9570204fe524ace4b46a8b402223f4255fd71b49585209370651ff7db9c9464c6c2e8a14b046f7757ae4bf2c0392013038ab1f3f1e9c5180f7f04
 DIST thunderbird-139.0.2-ast.xpi 342368 BLAKE2B 
83cd8f7ab4a3fa1d00bf1d867710c61a3b7a70e9a629654f05ea309907021911da405c9b875acf9a67dc8d924e4ece9eec3b674d3b74bbbf1a158856f70bdeca
 SHA512 
4fb5be29f1304a7d3897c32dce3291d42b6782e25fc07a4c9b5bbe96d7afb40c72dd2137d94ec18738819dc1cdc0436b24287d006ecd6aecc4ff6f2cd80bd77b

diff --git a/mail-client/thunderbird/thunderbird-128.13.0.ebuild 
b/mail-client/thunderbird/thunderbird-128.13.0.ebuild
new file mode 100644
index 000000000000..795cd1a95c47
--- /dev/null
+++ b/mail-client/thunderbird/thunderbird-128.13.0.ebuild
@@ -0,0 +1,1171 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+FIREFOX_PATCHSET="firefox-128esr-patches-12.tar.xz"
+
+LLVM_COMPAT=( 18 19 )
+
+PYTHON_COMPAT=( python3_{10..12} )
+PYTHON_REQ_USE="ncurses,sqlite,ssl"
+
+RUST_MIN_VER="1.77.1"
+RUST_NEEDS_LLVM=1
+
+WANT_AUTOCONF="2.1"
+
+VIRTUALX_REQUIRED="manual"
+
+# Thunderbird will have separate release and esr channels, matching Firefox's 
rapid and esr.
+MOZ_ESR=yes
+
+MOZ_PV=${PV}
+MOZ_PV_SUFFIX=
+if [[ ${PV} =~ (_(alpha|beta|rc).*)$ ]] ; then
+       MOZ_PV_SUFFIX=${BASH_REMATCH[1]}
+
+       # Convert the ebuild version to the upstream Mozilla version
+       MOZ_PV="${MOZ_PV/_alpha/a}" # Handle alpha for SRC_URI
+       MOZ_PV="${MOZ_PV/_beta/b}"  # Handle beta for SRC_URI
+       MOZ_PV="${MOZ_PV%%_rc*}"    # Handle rc for SRC_URI
+fi
+
+if [[ -n ${MOZ_ESR} ]] ; then
+       # ESR releases have slightly different version numbers
+       MOZ_PV="${MOZ_PV}esr"
+fi
+
+MOZ_PN="${PN%-bin}"
+MOZ_P="${MOZ_PN}-${MOZ_PV}"
+MOZ_PV_DISTFILES="${MOZ_PV}${MOZ_PV_SUFFIX}"
+MOZ_P_DISTFILES="${MOZ_PN}-${MOZ_PV_DISTFILES}"
+
+inherit autotools check-reqs desktop flag-o-matic gnome2-utils linux-info 
llvm-r1 multiprocessing \
+       optfeature pax-utils python-any-r1 rust toolchain-funcs virtualx xdg
+
+DESCRIPTION="Thunderbird Mail Client"
+HOMEPAGE="https://www.thunderbird.net/";
+
+MOZ_SRC_BASE_URI="https://archive.mozilla.org/pub/${MOZ_PN}/releases/${MOZ_PV}";
+
+if [[ ${PV} == *_rc* ]] ; then
+       
MOZ_SRC_BASE_URI="https://archive.mozilla.org/pub/${MOZ_PN}/candidates/${MOZ_PV}-candidates/build${PV##*_rc}";
+fi
+
+PATCH_URIS=(
+       https://dev.gentoo.org/~juippis/mozilla/patchsets/${FIREFOX_PATCHSET}
+)
+
+SRC_URI="${MOZ_SRC_BASE_URI}/source/${MOZ_P}.source.tar.xz -> 
${MOZ_P_DISTFILES}.source.tar.xz
+       ${PATCH_URIS[@]}"
+S="${WORKDIR}/${PN}-${PV%_*}"
+
+if [[ -n ${MOZ_ESR} ]] ; then
+       SLOT="0/esr"
+else
+       SLOT="0/stable"
+fi
+
+LICENSE="MPL-2.0 GPL-2 LGPL-2.1"
+KEYWORDS="~amd64 ~arm64 ~ppc64 ~x86"
+
+IUSE="+clang +dbus debug eme-free hardened hwaccel jack libproxy pgo 
pulseaudio sndio selinux"
+IUSE+=" +system-av1 +system-harfbuzz +system-icu +system-jpeg +system-libevent 
+system-libvpx"
+IUSE+=" system-png +system-webp wayland wifi +X"
+
+# Thunderbird-only USE flags.
+IUSE+=" +rust-extensions +system-librnp"
+
+REQUIRED_USE="|| ( X wayland )
+       debug? ( !system-av1 )
+       rust-extensions? ( dbus )
+       wayland? ( dbus )
+       wifi? ( dbus )"
+
+TB_ONLY_DEPEND="selinux? ( sec-policy/selinux-thunderbird )
+       !system-librnp? ( dev-libs/jsoncpp )
+       system-librnp? ( >=dev-util/librnp-0.17.1 )"
+BDEPEND="${PYTHON_DEPS}
+       $(llvm_gen_dep '
+               llvm-core/clang:${LLVM_SLOT}
+               llvm-core/llvm:${LLVM_SLOT}
+               clang? (
+                       llvm-core/lld:${LLVM_SLOT}
+                       pgo? ( 
llvm-runtimes/compiler-rt-sanitizers:${LLVM_SLOT}[profile] )
+               )
+       ')
+       app-alternatives/awk
+       app-arch/unzip
+       app-arch/zip
+       >=dev-util/cbindgen-0.26.0
+       net-libs/nodejs
+       virtual/pkgconfig
+       amd64? ( >=dev-lang/nasm-2.14 )
+       x86? ( >=dev-lang/nasm-2.14 )
+       pgo? (
+               X? (
+                       sys-devel/gettext
+                       x11-base/xorg-server[xvfb]
+                       x11-apps/xhost
+               )
+               !X? (
+                       || (
+                               gui-wm/tinywl
+                               <gui-libs/wlroots-0.17.3[tinywl(-)]
+                       )
+                       x11-misc/xkeyboard-config
+               )
+       )"
+COMMON_DEPEND="${TB_ONLY_DEPEND}
+       >=app-accessibility/at-spi2-core-2.46.0:2
+       dev-libs/expat
+       dev-libs/glib:2
+       dev-libs/libffi:=
+       >=dev-libs/nss-3.101
+       >=dev-libs/nspr-4.35
+       media-libs/alsa-lib
+       media-libs/fontconfig
+       media-libs/freetype
+       media-libs/mesa
+       media-video/ffmpeg
+       sys-libs/zlib
+       virtual/freedesktop-icon-theme
+       x11-libs/cairo
+       x11-libs/gdk-pixbuf:2
+       x11-libs/pango
+       x11-libs/pixman
+       dbus? ( sys-apps/dbus )
+       jack? ( virtual/jack )
+       pulseaudio? (
+               || (
+                       media-libs/libpulse
+                       >=media-sound/apulse-0.1.12-r4[sdk]
+               )
+       )
+       libproxy? ( net-libs/libproxy )
+       selinux? ( sec-policy/selinux-mozilla )
+       sndio? ( >=media-sound/sndio-1.8.0-r1 )
+       system-av1? (
+               >=media-libs/dav1d-1.0.0:=
+               >=media-libs/libaom-1.0.0:=
+       )
+       system-harfbuzz? (
+               >=media-gfx/graphite2-1.3.13
+               >=media-libs/harfbuzz-2.8.1:0=
+       )
+       system-icu? ( >=dev-libs/icu-74.1:= )
+       system-jpeg? ( >=media-libs/libjpeg-turbo-1.2.1:= )
+       system-libevent? ( >=dev-libs/libevent-2.1.12:0=[threads(+)] )
+       system-libvpx? ( >=media-libs/libvpx-1.8.2:0=[postproc] )
+       system-png? ( >=media-libs/libpng-1.6.35:0=[apng] )
+       system-webp? ( >=media-libs/libwebp-1.1.0:0= )
+       wayland? (
+               >=media-libs/libepoxy-1.5.10-r1
+               x11-libs/gtk+:3[wayland]
+       )
+       wifi? (
+               kernel_linux? (
+                       || (
+                               net-misc/networkmanager
+                               net-misc/connman[networkmanager]
+                       )
+                       sys-apps/dbus
+               )
+       )
+       X? (
+               virtual/opengl
+               x11-libs/cairo[X]
+               x11-libs/gtk+:3[X]
+               x11-libs/libX11
+               x11-libs/libXcomposite
+               x11-libs/libXdamage
+               x11-libs/libXext
+               x11-libs/libXfixes
+               x11-libs/libXrandr
+               x11-libs/libxcb:=
+       )"
+RDEPEND="${COMMON_DEPEND}
+       jack? ( virtual/jack )"
+DEPEND="${COMMON_DEPEND}
+       X? (
+               x11-base/xorg-proto
+               x11-libs/libICE
+               x11-libs/libSM
+       )"
+
+llvm_check_deps() {
+       if ! has_version -b "llvm-core/clang:${LLVM_SLOT}" ; then
+               einfo "llvm-core/clang:${LLVM_SLOT} is missing! Cannot use LLVM 
slot ${LLVM_SLOT} ..." >&2
+               return 1
+       fi
+
+       if use clang && ! tc-ld-is-mold ; then
+               if ! has_version -b "llvm-core/lld:${LLVM_SLOT}" ; then
+                       einfo "llvm-core/lld:${LLVM_SLOT} is missing! Cannot 
use LLVM slot ${LLVM_SLOT} ..." >&2
+                       return 1
+               fi
+       fi
+
+       if use pgo ; then
+               if ! has_version -b 
"=llvm-runtimes/compiler-rt-sanitizers-${LLVM_SLOT}*[profile]" ; then
+                       einfo 
"=llvm-runtimes/compiler-rt-sanitizers-${LLVM_SLOT}*[profile] is missing!" >&2
+                       einfo "Cannot use LLVM slot ${LLVM_SLOT} ..." >&2
+                       return 1
+               fi
+       fi
+
+       einfo "Using LLVM slot ${LLVM_SLOT} to build" >&2
+}
+
+MOZ_LANGS=(
+       af ar ast be bg br ca cak cs cy da de dsb
+       el en-CA en-GB en-US es-AR es-ES es-MX et eu
+       fi fr fy-NL ga-IE gd gl he hr hsb hu
+       id is it ja ka kab kk ko lt lv ms nb-NO nl nn-NO
+       pa-IN pl pt-BR pt-PT rm ro ru
+       sk sl sq sr sv-SE th tr uk uz vi zh-CN zh-TW
+)
+
+mozilla_set_globals() {
+       # https://bugs.gentoo.org/587334
+       local MOZ_TOO_REGIONALIZED_FOR_L10N=(
+               fy-NL ga-IE gu-IN hi-IN hy-AM nb-NO ne-NP nn-NO pa-IN sv-SE
+       )
+
+       local lang xflag
+       for lang in "${MOZ_LANGS[@]}" ; do
+               # en and en_US are handled internally
+               if [[ ${lang} == en ]] || [[ ${lang} == en-US ]] ; then
+                       continue
+               fi
+
+               # strip region subtag if $lang is in the list
+               if has ${lang} "${MOZ_TOO_REGIONALIZED_FOR_L10N[@]}" ; then
+                       xflag=${lang%%-*}
+               else
+                       xflag=${lang}
+               fi
+
+               SRC_URI+=" l10n_${xflag/[_@]/-}? ("
+               SRC_URI+=" ${MOZ_SRC_BASE_URI}/linux-x86_64/xpi/${lang}.xpi -> 
${MOZ_P_DISTFILES}-${lang}.xpi"
+               SRC_URI+=" )"
+               IUSE+=" l10n_${xflag/[_@]/-}"
+       done
+}
+mozilla_set_globals
+
+moz_clear_vendor_checksums() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if [[ ${#} -ne 1 ]] ; then
+               die "${FUNCNAME} requires exact one argument"
+       fi
+
+       einfo "Clearing cargo checksums for ${1} ..."
+
+       sed -i \
+               -e 's/\("files":{\)[^}]*/\1/' \
+               "${S}"/third_party/rust/${1}/.cargo-checksum.json || die
+}
+
+moz_install_xpi() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if [[ ${#} -lt 2 ]] ; then
+               die "${FUNCNAME} requires at least two arguments"
+       fi
+
+       local DESTDIR=${1}
+       shift
+
+       insinto "${DESTDIR}"
+
+       local emid xpi_file xpi_tmp_dir
+       for xpi_file in "${@}" ; do
+               emid=
+               xpi_tmp_dir=$(mktemp -d --tmpdir="${T}")
+
+               # Unpack XPI
+               unzip -qq "${xpi_file}" -d "${xpi_tmp_dir}" || die
+
+               # Determine extension ID
+               if [[ -f "${xpi_tmp_dir}/install.rdf" ]] ; then
+                       emid=$(sed -n -e '/install-manifest/,$ { /em:id/!d; 
s/.*[\">]\([^\"<>]*\)[\"<].*/\1/; p; q }' "${xpi_tmp_dir}/install.rdf")
+                       [[ -z "${emid}" ]] && die "failed to determine 
extension id from install.rdf"
+               elif [[ -f "${xpi_tmp_dir}/manifest.json" ]] ; then
+                       emid=$(sed -n -e 's/.*"id": "\([^"]*\)".*/\1/p' 
"${xpi_tmp_dir}/manifest.json")
+                       [[ -z "${emid}" ]] && die "failed to determine 
extension id from manifest.json"
+               else
+                       die "failed to determine extension id"
+               fi
+
+               einfo "Installing ${emid}.xpi into ${ED}${DESTDIR} ..."
+               newins "${xpi_file}" "${emid}.xpi"
+       done
+}
+
+mozconfig_add_options_ac() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if [[ ${#} -lt 2 ]] ; then
+               die "${FUNCNAME} requires at least two arguments"
+       fi
+
+       local reason=${1}
+       shift
+
+       local option
+       for option in ${@} ; do
+               echo "ac_add_options ${option} # ${reason}" >>${MOZCONFIG}
+       done
+}
+
+mozconfig_add_options_mk() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if [[ ${#} -lt 2 ]] ; then
+               die "${FUNCNAME} requires at least two arguments"
+       fi
+
+       local reason=${1}
+       shift
+
+       local option
+       for option in ${@} ; do
+               echo "mk_add_options ${option} # ${reason}" >>${MOZCONFIG}
+       done
+}
+
+mozconfig_use_enable() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if [[ ${#} -lt 1 ]] ; then
+               die "${FUNCNAME} requires at least one arguments"
+       fi
+
+       local flag=$(use_enable "${@}")
+       mozconfig_add_options_ac "$(use ${1} && echo +${1} || echo -${1})" 
"${flag}"
+}
+
+mozconfig_use_with() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       if [[ ${#} -lt 1 ]] ; then
+               die "${FUNCNAME} requires at least one arguments"
+       fi
+
+       local flag=$(use_with "${@}")
+       mozconfig_add_options_ac "$(use ${1} && echo +${1} || echo -${1})" 
"${flag}"
+}
+
+virtwl() {
+       debug-print-function ${FUNCNAME} "$@"
+
+       [[ $# -lt 1 ]] && die "${FUNCNAME} needs at least one argument"
+       [[ -n $XDG_RUNTIME_DIR ]] || die "${FUNCNAME} needs XDG_RUNTIME_DIR to 
be set; try xdg_environment_reset"
+       tinywl -h >/dev/null || die 'tinywl -h failed'
+
+       local VIRTWL VIRTWL_PID
+       coproc VIRTWL { WLR_BACKENDS=headless exec tinywl -s 'echo 
$WAYLAND_DISPLAY; read _; kill $PPID'; }
+       local -x WAYLAND_DISPLAY
+       read WAYLAND_DISPLAY <&${VIRTWL[0]}
+
+       debug-print "${FUNCNAME}: $@"
+       "$@"
+       local r=$?
+
+       [[ -n $VIRTWL_PID ]] || die "tinywl exited unexpectedly"
+       exec {VIRTWL[0]}<&- {VIRTWL[1]}>&-
+       return $r
+}
+
+pkg_pretend() {
+       if [[ ${MERGE_TYPE} != binary ]] ; then
+               if use pgo ; then
+                       if ! has usersandbox $FEATURES ; then
+                               die "You must enable usersandbox as X server 
can not run as root!"
+                       fi
+               fi
+
+               # Ensure we have enough disk space to compile
+               if use pgo || use debug ; then
+                       CHECKREQS_DISK_BUILD="14300M"
+               elif tc-is-lto ; then
+                       CHECKREQS_DISK_BUILD="10600M"
+               else
+                       CHECKREQS_DISK_BUILD="6800M"
+               fi
+
+               check-reqs_pkg_pretend
+       fi
+}
+
+pkg_setup() {
+
+       # Get LTO from environment; export after this phase for use in 
src_configure (etc)
+       use_lto=no
+
+       if [[ ${MERGE_TYPE} != binary ]] ; then
+
+               if tc-is-lto; then
+                       use_lto=yes
+                       # LTO is handled via configure
+                       filter-lto
+               fi
+
+               if use pgo ; then
+                       if ! has userpriv ${FEATURES} ; then
+                               eerror "Building ${PN} with USE=pgo and 
FEATURES=-userpriv is not supported!"
+                       fi
+               fi
+
+               if [[ ${use_lto} = yes ]] ; then
+                       # -Werror=lto-type-mismatch -Werror=odr are going to 
fail with GCC,
+                       # bmo#1516758, bgo#942288
+                       filter-flags -Werror=lto-type-mismatch -Werror=odr
+               fi
+
+               if use pgo || use debug ; then
+                       CHECKREQS_DISK_BUILD="14300M"
+               elif [[ ${use_lto} == "yes" ]] ; then
+                       CHECKREQS_DISK_BUILD="10600M"
+               else
+                       CHECKREQS_DISK_BUILD="6800M"
+               fi
+
+               check-reqs_pkg_setup
+               llvm-r1_pkg_setup
+               rust_pkg_setup
+               python-any-r1_pkg_setup
+
+               # Avoid PGO profiling problems due to enviroment leakage
+               # These should *always* be cleaned up anyway
+               unset \
+                       DBUS_SESSION_BUS_ADDRESS \
+                       DISPLAY \
+                       ORBIT_SOCKETDIR \
+                       SESSION_MANAGER \
+                       XAUTHORITY \
+                       XDG_CACHE_HOME \
+                       XDG_SESSION_COOKIE
+
+               # Build system is using /proc/self/oom_score_adj, bug #604394
+               addpredict /proc/self/oom_score_adj
+
+               if use pgo ; then
+                       # Update 105.0: "/proc/self/oom_score_adj" isn't enough 
anymore with pgo, but not sure
+                       # whether that's due to better OOM handling by Firefox 
(bmo#1771712), or portage
+                       # (PORTAGE_SCHEDULING_POLICY) update...
+                       addpredict /proc
+
+                       # Clear tons of conditions, since PGO is 
hardware-dependant.
+                       addpredict /dev
+               fi
+
+               if ! mountpoint -q /dev/shm ; then
+                       # If /dev/shm is not available, configure is known to 
fail with
+                       # a traceback report referencing 
/usr/lib/pythonN.N/multiprocessing/synchronize.py
+                       ewarn "/dev/shm is not mounted -- expect build 
failures!"
+               fi
+
+               # Google API keys (see 
http://www.chromium.org/developers/how-tos/api-keys)
+               # Note: These are for Gentoo Linux use ONLY. For your own 
distribution, please
+               # get your own set of keys.
+               if [[ -z "${MOZ_API_KEY_GOOGLE+set}" ]] ; then
+                       
MOZ_API_KEY_GOOGLE="AIzaSyDEAOvatFogGaPi0eTgsV_ZlEzx0ObmepsMzfAc"
+               fi
+
+               if [[ -z "${MOZ_API_KEY_LOCATION+set}" ]] ; then
+                       
MOZ_API_KEY_LOCATION="AIzaSyB2h2OuRgGaPicUgy5N-5hsZqiPW6sH3n_rptiQ"
+               fi
+
+               # Mozilla API keys (see 
https://location.services.mozilla.com/api)
+               # Note: These are for Gentoo Linux use ONLY. For your own 
distribution, please
+               # get your own set of keys.
+               if [[ -z "${MOZ_API_KEY_MOZILLA+set}" ]] ; then
+                       
MOZ_API_KEY_MOZILLA="edb3d487-3a84-46m0ap1e3-9dfd-92b5efaaa005"
+               fi
+
+               # Ensure we use C locale when building, bug #746215
+               export LC_ALL=C
+       fi
+
+       export use_lto
+}
+
+src_unpack() {
+       local _lp_dir="${WORKDIR}/language_packs"
+       local _src_file
+
+       if [[ ! -d "${_lp_dir}" ]] ; then
+               mkdir "${_lp_dir}" || die
+       fi
+
+       for _src_file in ${A} ; do
+               if [[ ${_src_file} == *.xpi ]]; then
+                       cp "${DISTDIR}/${_src_file}" "${_lp_dir}" || die 
"Failed to copy '${_src_file}' to '${_lp_dir}'!"
+               else
+                       unpack ${_src_file}
+               fi
+       done
+}
+
+src_prepare() {
+       if [[ ${use_lto} == "yes" ]]; then
+               rm -v 
"${WORKDIR}"/firefox-patches/*-LTO-Only-enable-LTO-*.patch || die
+       fi
+
+       # Workaround for bgo#917599
+       if has_version ">=dev-libs/icu-74.1" && use system-icu ; then
+               eapply 
"${WORKDIR}"/firefox-patches/*-bmo-1862601-system-icu-74.patch
+       fi
+       rm -v "${WORKDIR}"/firefox-patches/*-bmo-1862601-system-icu-74.patch || 
die
+
+       # Workaround for bgo#915651 on musl
+       if use elibc_glibc ; then
+               rm -v 
"${WORKDIR}"/firefox-patches/*bgo-748849-RUST_TARGET_override.patch || die
+       fi
+
+       eapply "${WORKDIR}/firefox-patches"
+
+       # Allow user to apply any additional patches without modifing ebuild
+       eapply_user
+
+       # Make cargo respect MAKEOPTS
+       export CARGO_BUILD_JOBS="$(makeopts_jobs)"
+
+       # Workaround for bgo#915651
+       if ! use elibc_glibc ; then
+               if use amd64 ; then
+                       export RUST_TARGET="x86_64-unknown-linux-musl"
+               elif use x86 ; then
+                       export RUST_TARGET="i686-unknown-linux-musl"
+               elif use arm64 ; then
+                       export RUST_TARGET="aarch64-unknown-linux-musl"
+               elif use ppc64 ; then
+                       export RUST_TARGET="powerpc64le-unknown-linux-musl"
+               elif use riscv ; then
+                       # We can pretty safely rule out any 32-bit riscvs, but 
64-bit riscvs also have tons of
+                       # different ABIs available. 
riscv64gc-unknown-linux-musl seems to be the best working
+                       # guess right now though.
+                       elog "riscv detected, forcing a riscv64 target for now."
+                       export RUST_TARGET="riscv64gc-unknown-linux-musl"
+               else
+                       die "Unknown musl chost, please post a new bug with 
your rustc -vV along with emerge --info"
+               fi
+       fi
+
+       # Make LTO respect MAKEOPTS
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               "${S}"/build/moz.configure/lto-pgo.configure || die "Failed 
sedding multiprocessing.cpu_count"
+
+       # Make ICU respect MAKEOPTS
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               "${S}"/intl/icu_sources_data.py || die "Failed sedding 
multiprocessing.cpu_count"
+
+       # Respect MAKEOPTS all around (maybe some find+sed is better)
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               "${S}"/python/mozbuild/mozbuild/base.py || die "Failed sedding 
multiprocessing.cpu_count"
+
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               "${S}"/third_party/libwebrtc/build/toolchain/get_cpu_count.py 
|| die "Failed sedding multiprocessing.cpu_count"
+
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               
"${S}"/third_party/libwebrtc/build/toolchain/get_concurrent_links.py ||
+                       die "Failed sedding multiprocessing.cpu_count"
+
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               "${S}"/third_party/python/gyp/pylib/gyp/input.py || die "Failed 
sedding multiprocessing.cpu_count"
+
+       sed -i -e "s/multiprocessing.cpu_count()/$(makeopts_jobs)/" \
+               "${S}"/python/mozbuild/mozbuild/code_analysis/mach_commands.py 
|| die "Failed sedding multiprocessing.cpu_count"
+
+       # sed-in toolchain prefix
+       sed -i \
+               -e "s/objdump/${CHOST}-objdump/" \
+               "${S}"/python/mozbuild/mozbuild/configure/check_debug_ranges.py 
|| die "sed failed to set toolchain prefix"
+
+       sed -i \
+               -e 's/ccache_stats = None/return None/' \
+               "${S}"/python/mozbuild/mozbuild/controller/building.py || die 
"sed failed to disable ccache stats call"
+
+       einfo "Removing pre-built binaries ..."
+
+       find "${S}"/third_party -type f \( -name '*.so' -o -name '*.o' \) 
-print -delete || die
+
+       # Clear checksums from cargo crates we've manually patched.
+       # moz_clear_vendor_checksums xyz
+
+       # Create build dir
+       BUILD_DIR="${WORKDIR}/${PN}_build"
+       mkdir -p "${BUILD_DIR}" || die
+
+       # Write API keys to disk
+       echo -n "${MOZ_API_KEY_GOOGLE//gGaPi/}" > "${S}"/api-google.key || die
+       echo -n "${MOZ_API_KEY_LOCATION//gGaPi/}" > "${S}"/api-location.key || 
die
+       echo -n "${MOZ_API_KEY_MOZILLA//m0ap1/}" > "${S}"/api-mozilla.key || die
+
+       xdg_environment_reset
+}
+
+src_configure() {
+       # Show flags set at the beginning
+       einfo "Current BINDGEN_CFLAGS:\t${BINDGEN_CFLAGS:-no value set}"
+       einfo "Current CFLAGS:\t\t${CFLAGS:-no value set}"
+       einfo "Current CXXFLAGS:\t\t${CXXFLAGS:-no value set}"
+       einfo "Current LDFLAGS:\t\t${LDFLAGS:-no value set}"
+       einfo "Current RUSTFLAGS:\t\t${RUSTFLAGS:-no value set}"
+
+       local have_switched_compiler=
+       if use clang; then
+               # Force clang
+               einfo "Enforcing the use of clang due to USE=clang ..."
+
+               local version_clang=$(clang --version 2>/dev/null | grep -F -- 
'clang version' | awk '{ print $3 }')
+               [[ -n ${version_clang} ]] && version_clang=$(ver_cut 1 
"${version_clang}")
+               [[ -z ${version_clang} ]] && die "Failed to read clang version!"
+
+               if tc-is-gcc; then
+                       have_switched_compiler=yes
+               fi
+
+               AR=llvm-ar
+               CC=${CHOST}-clang-${version_clang}
+               CXX=${CHOST}-clang++-${version_clang}
+               NM=llvm-nm
+               RANLIB=llvm-ranlib
+       elif ! use clang && ! tc-is-gcc ; then
+               # Force gcc
+               have_switched_compiler=yes
+               einfo "Enforcing the use of gcc due to USE=-clang ..."
+               AR=gcc-ar
+               CC=${CHOST}-gcc
+               CXX=${CHOST}-g++
+               NM=gcc-nm
+               RANLIB=gcc-ranlib
+       fi
+
+       if [[ -n "${have_switched_compiler}" ]] ; then
+               # Because we switched active compiler we have to ensure
+               # that no unsupported flags are set
+               strip-unsupported-flags
+       fi
+
+       # Ensure we use correct toolchain,
+       # AS is used in a non-standard way by upstream, #bmo1654031
+       export HOST_CC="$(tc-getBUILD_CC)"
+       export HOST_CXX="$(tc-getBUILD_CXX)"
+       export AS="$(tc-getCC) -c"
+
+       # Configuration tests expect llvm-readelf output, bug 913130
+       READELF="llvm-readelf"
+
+       tc-export CC CXX LD AR AS NM OBJDUMP RANLIB READELF PKG_CONFIG
+
+       # Pass the correct toolchain paths through cbindgen
+       if tc-is-cross-compiler ; then
+               export BINDGEN_CFLAGS="${SYSROOT:+--sysroot=${ESYSROOT}} 
--target=${CHOST} ${BINDGEN_CFLAGS-}"
+       fi
+
+       # Set MOZILLA_FIVE_HOME
+       export MOZILLA_FIVE_HOME="/usr/$(get_libdir)/${PN}"
+
+       # python/mach/mach/mixin/process.py fails to detect SHELL
+       export SHELL="${EPREFIX}/bin/bash"
+
+       # Set state path
+       export MOZBUILD_STATE_PATH="${BUILD_DIR}"
+
+       # Set MOZCONFIG
+       export MOZCONFIG="${S}/.mozconfig"
+
+       # Initialize MOZCONFIG
+       mozconfig_add_options_ac '' --enable-application=comm/mail
+       mozconfig_add_options_ac '' --enable-project=comm/mail
+
+       # Set Gentoo defaults
+       mozconfig_add_options_ac 'Gentoo default' \
+               --allow-addon-sideload \
+               --disable-cargo-incremental \
+               --disable-crashreporter \
+               --disable-disk-remnant-avoidance \
+               --disable-geckodriver \
+               --disable-gpsd \
+               --disable-install-strip \
+               --disable-legacy-profile-creation \
+               --disable-parental-controls \
+               --disable-strip \
+               --disable-tests \
+               --disable-updater \
+               --disable-valgrind \
+               --disable-wmf \
+               --enable-js-shell \
+               --enable-negotiateauth \
+               --enable-new-pass-manager \
+               --enable-official-branding \
+               --enable-release \
+               --enable-system-pixman \
+               --enable-system-policies \
+               --host="${CBUILD:-${CHOST}}" \
+               --libdir="${EPREFIX}/usr/$(get_libdir)" \
+               --prefix="${EPREFIX}/usr" \
+               --target="${CHOST}" \
+               --without-ccache \
+               --without-wasm-sandboxed-libraries \
+               --with-intl-api \
+               --with-libclang-path="$(llvm-config --libdir)" \
+               --with-system-ffi \
+               --with-system-nspr \
+               --with-system-nss \
+               --with-system-zlib \
+               --with-toolchain-prefix="${CHOST}-" \
+               --with-unsigned-addon-scopes=app,system \
+               --x-includes="${ESYSROOT}/usr/include" \
+               --x-libraries="${ESYSROOT}/usr/$(get_libdir)"
+
+       # Set update channel
+       local update_channel=release
+       [[ -n ${MOZ_ESR} ]] && update_channel=esr
+       mozconfig_add_options_ac '' --enable-update-channel=${update_channel}
+
+       if ! use x86 ; then
+               mozconfig_add_options_ac '' --enable-rust-simd
+       fi
+
+       # For future keywording: This is currently (97.0) only supported on:
+       # amd64, arm, arm64 & x86.
+       # Might want to flip the logic around if Firefox is to support more 
arches.
+       # bug 833001, bug 903411#c8
+       if use ppc64 || use riscv; then
+               mozconfig_add_options_ac '' --disable-sandbox
+       else
+               mozconfig_add_options_ac '' --enable-sandbox
+       fi
+
+       # Enable JIT on riscv64 explicitly, since it's not activated 
automatically via "known arches" list.
+       # Update 128.1.0: Disable jit on riscv (this line can be blanked to 
disable by default),
+       # bgo#937867.
+       use riscv && mozconfig_add_options_ac 'Disable JIT for RISC-V 64' 
--disable-jit
+
+       if [[ -s "${S}/api-google.key" ]] ; then
+               local key_origin="Gentoo default"
+               if [[ $(cat "${S}/api-google.key" | md5sum | awk '{ print $1 
}') != 709560c02f94b41f9ad2c49207be6c54 ]] ; then
+                       key_origin="User value"
+               fi
+
+               mozconfig_add_options_ac "${key_origin}" \
+                       
--with-google-safebrowsing-api-keyfile="${S}/api-google.key"
+       else
+               einfo "Building without Google API key ..."
+       fi
+
+       if [[ -s "${S}/api-location.key" ]] ; then
+               local key_origin="Gentoo default"
+               if [[ $(cat "${S}/api-location.key" | md5sum | awk '{ print $1 
}') != ffb7895e35dedf832eb1c5d420ac7420 ]] ; then
+                       key_origin="User value"
+               fi
+
+               mozconfig_add_options_ac "${key_origin}" \
+                       
--with-google-location-service-api-keyfile="${S}/api-location.key"
+       else
+               einfo "Building without Location API key ..."
+       fi
+
+       if [[ -s "${S}/api-mozilla.key" ]] ; then
+               local key_origin="Gentoo default"
+               if [[ $(cat "${S}/api-mozilla.key" | md5sum | awk '{ print $1 
}') != 3927726e9442a8e8fa0e46ccc39caa27 ]] ; then
+                       key_origin="User value"
+               fi
+
+               mozconfig_add_options_ac "${key_origin}" \
+                       --with-mozilla-api-keyfile="${S}/api-mozilla.key"
+       else
+               einfo "Building without Mozilla API key ..."
+       fi
+
+       mozconfig_use_enable rust-extensions thunderbird-rust
+
+       mozconfig_use_with system-av1
+       mozconfig_use_with system-harfbuzz
+       mozconfig_use_with system-harfbuzz system-graphite2
+       mozconfig_use_with system-icu
+       mozconfig_use_with system-jpeg
+       mozconfig_use_with system-libevent
+       mozconfig_use_with system-libvpx
+       mozconfig_use_with system-png
+       mozconfig_use_with system-webp
+
+       if use system-librnp; then
+               mozconfig_add_options_ac "+system-librnp" 
--enable-compile-environment
+               mozconfig_use_with system-librnp
+       else
+               # This controls the backend of the bundled librnp. Choices are 
"botan" and "openssl".
+               # RNP Upstream recommends to use botan. In Gentoo it's 
preferred to use system-librnp.
+               mozconfig_add_options_ac "+bundled librnp backend = botan" 
--with-librnp-backend="botan"
+       fi
+
+       mozconfig_use_enable dbus
+       mozconfig_use_enable libproxy
+
+       use eme-free && mozconfig_add_options_ac '+eme-free' --disable-eme
+
+       if use hardened ; then
+               mozconfig_add_options_ac "+hardened" --enable-hardening
+               append-ldflags "-Wl,-z,relro -Wl,-z,now"
+
+               # Increase the FORTIFY_SOURCE value, #910071.
+               sed -i -e '/-D_FORTIFY_SOURCE=/s:2:3:' 
"${S}"/build/moz.configure/toolchain.configure || die
+       fi
+
+       local myaudiobackends=""
+       use jack && myaudiobackends+="jack,"
+       use sndio && myaudiobackends+="sndio,"
+       use pulseaudio && myaudiobackends+="pulseaudio,"
+       ! use pulseaudio && myaudiobackends+="alsa,"
+
+       mozconfig_add_options_ac '--enable-audio-backends' 
--enable-audio-backends="${myaudiobackends::-1}"
+
+       mozconfig_use_enable wifi necko-wifi
+
+       if use X && use wayland ; then
+               mozconfig_add_options_ac '+x11+wayland' 
--enable-default-toolkit=cairo-gtk3-x11-wayland
+       elif ! use X && use wayland ; then
+               mozconfig_add_options_ac '+wayland' 
--enable-default-toolkit=cairo-gtk3-wayland-only
+       else
+               mozconfig_add_options_ac '+x11' 
--enable-default-toolkit=cairo-gtk3-x11-only
+       fi
+
+       if [[ ${use_lto} == "yes" ]] ; then
+               if use clang ; then
+                       # Upstream only supports lld or mold when using clang.
+                       if tc-ld-is-mold ; then
+                               # mold expects the -flto line from *FLAGS 
configuration, bgo#923119
+                               append-ldflags "-flto=thin"
+                               mozconfig_add_options_ac "using ld=mold due to 
system selection" --enable-linker=mold
+                       else
+                               mozconfig_add_options_ac "forcing ld=lld due to 
USE=clang and USE=lto" --enable-linker=lld
+                       fi
+
+                       mozconfig_add_options_ac '+lto' --enable-lto=cross
+
+               else
+                       # ThinLTO is currently broken, see bmo#1644409.
+                       # mold does not support gcc+lto combination.
+                       mozconfig_add_options_ac '+lto' --enable-lto=full
+                       mozconfig_add_options_ac "linker is set to bfd" 
--enable-linker=bfd
+               fi
+
+       else
+               # Avoid auto-magic on linker
+               if use clang ; then
+                       # lld is upstream's default
+                       if tc-ld-is-mold ; then
+                               mozconfig_add_options_ac "using ld=mold due to 
system selection" --enable-linker=mold
+                       else
+                               mozconfig_add_options_ac "forcing ld=lld due to 
USE=clang" --enable-linker=lld
+                       fi
+
+               else
+                       if tc-ld-is-mold ; then
+                               mozconfig_add_options_ac "using ld=mold due to 
system selection" --enable-linker=mold
+                       else
+                               mozconfig_add_options_ac "linker is set to bfd 
due to USE=-clang" --enable-linker=bfd
+                       fi
+               fi
+       fi
+
+       if use pgo ; then
+               mozconfig_add_options_ac '+pgo' MOZ_PGO=1
+
+               if use clang ; then
+                       # Used in build/pgo/profileserver.py
+                       export LLVM_PROFDATA="llvm-profdata"
+               fi
+       fi
+
+       mozconfig_use_enable debug
+       if use debug ; then
+               mozconfig_add_options_ac '+debug' --disable-optimize
+               mozconfig_add_options_ac '+debug' --enable-jemalloc
+               mozconfig_add_options_ac '+debug' --enable-real-time-tracing
+       else
+               mozconfig_add_options_ac 'Gentoo defaults' 
--disable-real-time-tracing
+
+               if is-flag '-g*' ; then
+                       if use clang ; then
+                               mozconfig_add_options_ac 'from CFLAGS' 
--enable-debug-symbols=$(get-flag '-g*')
+                       else
+                               mozconfig_add_options_ac 'from CFLAGS' 
--enable-debug-symbols
+                       fi
+               else
+                       mozconfig_add_options_ac 'Gentoo default' 
--disable-debug-symbols
+               fi
+
+               if is-flag '-O0' ; then
+                       mozconfig_add_options_ac "from CFLAGS" 
--enable-optimize=-O0
+               elif is-flag '-O4' ; then
+                       mozconfig_add_options_ac "from CFLAGS" 
--enable-optimize=-O4
+               elif is-flag '-O3' ; then
+                       mozconfig_add_options_ac "from CFLAGS" 
--enable-optimize=-O3
+               elif is-flag '-O1' ; then
+                       mozconfig_add_options_ac "from CFLAGS" 
--enable-optimize=-O1
+               elif is-flag '-Os' ; then
+                       mozconfig_add_options_ac "from CFLAGS" 
--enable-optimize=-Os
+               else
+                       mozconfig_add_options_ac "Gentoo default" 
--enable-optimize=-O2
+               fi
+       fi
+
+       # Debug flag was handled via configure
+       filter-flags '-g*'
+
+       # Optimization flag was handled via configure
+       filter-flags '-O*'
+
+       # elf-hack
+       # Filter "-z,pack-relative-relocs" and let the build system handle it 
instead.
+       if use amd64 || use x86 ; then
+               filter-flags "-z,pack-relative-relocs"
+
+               if tc-ld-is-mold ; then
+                       # relr-elf-hack is currently broken with mold, 
bgo#916259
+                       mozconfig_add_options_ac 'disable elf-hack with mold 
linker' --disable-elf-hack
+               else
+                       mozconfig_add_options_ac 'relr elf-hack' 
--enable-elf-hack=relr
+               fi
+       elif use ppc64 || use riscv ; then
+               # '--disable-elf-hack' is not recognized on ppc64/riscv,
+               # see bgo #917049, #930046
+               :;
+       else
+               mozconfig_add_options_ac 'disable elf-hack on non-supported 
arches' --disable-elf-hack
+       fi
+
+       if ! use elibc_glibc; then
+               mozconfig_add_options_ac '!elibc_glibc' --disable-jemalloc
+       fi
+
+       # System-av1 fix
+       use system-av1 && append-ldflags "-Wl,--undefined-version"
+
+       # Make revdep-rebuild.sh happy; Also required for musl
+       append-ldflags -Wl,-rpath="${MOZILLA_FIVE_HOME}",--enable-new-dtags
+
+       # Pass $MAKEOPTS to build system
+       export MOZ_MAKE_FLAGS="${MAKEOPTS}"
+
+       # Use system's Python environment
+       export PIP_NETWORK_INSTALL_RESTRICTED_VIRTUALENVS=mach
+
+       export MACH_BUILD_PYTHON_NATIVE_PACKAGE_SOURCE="none"
+
+       # Disable notification when build system has finished
+       export MOZ_NOSPAM=1
+
+       # Portage sets XARGS environment variable to "xargs -r" by default which
+       # breaks build system's check_prog() function which doesn't support 
arguments
+       mozconfig_add_options_ac 'Gentoo default' 
"XARGS=${EPREFIX}/usr/bin/xargs"
+
+       # Set build dir
+       mozconfig_add_options_mk 'Gentoo default' "MOZ_OBJDIR=${BUILD_DIR}"
+
+       # Show flags we will use
+       einfo "Build BINDGEN_CFLAGS:\t${BINDGEN_CFLAGS:-no value set}"
+       einfo "Build CFLAGS:\t\t${CFLAGS:-no value set}"
+       einfo "Build CXXFLAGS:\t\t${CXXFLAGS:-no value set}"
+       einfo "Build LDFLAGS:\t\t${LDFLAGS:-no value set}"
+       einfo "Build RUSTFLAGS:\t\t${RUSTFLAGS:-no value set}"
+
+       # Handle EXTRA_CONF and show summary
+       local ac opt hash reason
+
+       # Apply EXTRA_ECONF entries to $MOZCONFIG
+       if [[ -n ${EXTRA_ECONF} ]] ; then
+               IFS=\! read -a ac <<<${EXTRA_ECONF// --/\!}
+               for opt in "${ac[@]}"; do
+                       mozconfig_add_options_ac "EXTRA_ECONF" --${opt#--}
+               done
+       fi
+
+       echo
+       echo "=========================================================="
+       echo "Building ${PF} with the following configuration"
+       grep ^ac_add_options "${MOZCONFIG}" | while read ac opt hash reason; do
+               [[ -z ${hash} || ${hash} == \# ]] \
+                       || die "error reading mozconfig: ${ac} ${opt} ${hash} 
${reason}"
+               printf "    %-30s  %s\n" "${opt}" "${reason:-mozilla.org 
default}"
+       done
+       echo "=========================================================="
+       echo
+
+       ./mach configure || die
+}
+
+src_compile() {
+       local virtx_cmd=
+
+       if [[ ${use_lto} == "yes" ]] && tc-ld-is-mold ; then
+               # increase ulimit with mold+lto, bugs #892641, #907485
+               if ! ulimit -n 16384 1>/dev/null 2>&1 ; then
+                       ewarn "Unable to modify ulimits - building with 
mold+lto might fail due to low ulimit -n resources."
+                       ewarn "Please see bugs #892641 & #907485."
+               else
+                       ulimit -n 16384
+               fi
+       fi
+
+       if use pgo; then
+               # Reset and cleanup environment variables used by GNOME/XDG
+               gnome2_environment_reset
+
+               addpredict /root
+
+               if ! use X; then
+                       virtx_cmd=virtwl
+               else
+                       virtx_cmd=virtx
+               fi
+       fi
+
+       if ! use X; then
+               local -x GDK_BACKEND=wayland
+       else
+               local -x GDK_BACKEND=x11
+       fi
+
+       ${virtx_cmd} ./mach build --verbose || die
+}
+
+src_install() {
+       # xpcshell is getting called during install
+       pax-mark m \
+               "${BUILD_DIR}"/dist/bin/xpcshell \
+               "${BUILD_DIR}"/dist/bin/${PN} \
+               "${BUILD_DIR}"/dist/bin/plugin-container
+
+       DESTDIR="${D}" ./mach install || die
+
+       # Upstream cannot ship symlink but we can (bmo#658850)
+       rm "${ED}${MOZILLA_FIVE_HOME}/${PN}-bin" || die
+       dosym ${PN} ${MOZILLA_FIVE_HOME}/${PN}-bin
+
+       # Don't install llvm-symbolizer from llvm-core/llvm package
+       if [[ -f "${ED}${MOZILLA_FIVE_HOME}/llvm-symbolizer" ]] ; then
+               rm -v "${ED}${MOZILLA_FIVE_HOME}/llvm-symbolizer" || die
+       fi
+
+       # Install policy (currently only used to disable application updates)
+       insinto "${MOZILLA_FIVE_HOME}/distribution"
+       newins "${FILESDIR}"/distribution.ini distribution.ini
+       newins "${FILESDIR}"/disable-auto-update.policy.json policies.json
+
+       # Install system-wide preferences
+       local PREFS_DIR="${MOZILLA_FIVE_HOME}/defaults/pref"
+       insinto "${PREFS_DIR}"
+       newins "${FILESDIR}"/gentoo-default-prefs-r1.js gentoo-prefs.js
+
+       local GENTOO_PREFS="${ED}${PREFS_DIR}/gentoo-prefs.js"
+
+       # Force hwaccel prefs if USE=hwaccel is enabled
+       if use hwaccel ; then
+               cat "${FILESDIR}"/gentoo-hwaccel-prefs.js \
+               >>"${GENTOO_PREFS}" \
+               || die "failed to add prefs to force hardware-accelerated 
rendering to all-gentoo.js"
+
+               if use wayland; then
+                       cat >>"${GENTOO_PREFS}" <<-EOF || die "failed to set 
hwaccel wayland prefs"
+                       pref("gfx.x11-egl.force-enabled",          false);
+                       EOF
+               else
+                       cat >>"${GENTOO_PREFS}" <<-EOF || die "failed to set 
hwaccel x11 prefs"
+                       pref("gfx.x11-egl.force-enabled",          true);
+                       EOF
+               fi
+       fi
+
+       # Set dictionary path to use system hunspell
+       cat >>"${GENTOO_PREFS}" <<-EOF || die "failed to set 
spellchecker.dictionary_path pref"
+       pref("spellchecker.dictionary_path",       
"${EPREFIX}/usr/share/myspell");
+       EOF
+
+       # Force the graphite pref if USE=system-harfbuzz is enabled, since the 
pref cannot disable it
+       if use system-harfbuzz ; then
+               cat >>"${GENTOO_PREFS}" <<-EOF || die "failed to set 
gfx.font_rendering.graphite.enabled pref"
+               sticky_pref("gfx.font_rendering.graphite.enabled", true);
+               EOF
+       fi
+
+       # Install language packs
+       local langpacks=( $(find "${WORKDIR}/language_packs" -type f -name 
'*.xpi') )
+       if [[ -n "${langpacks}" ]] ; then
+               moz_install_xpi "${MOZILLA_FIVE_HOME}/distribution/extensions" 
"${langpacks[@]}"
+       fi
+
+       # Install icons
+       local icon_srcdir="${S}/comm/mail/branding/thunderbird"
+       local icon_symbolic_file="${icon_srcdir}/TB-symbolic.svg"
+
+       insinto /usr/share/icons/hicolor/symbolic/apps
+       newins "${icon_symbolic_file}" ${PN}-symbolic.svg
+
+       local icon size
+       for icon in "${icon_srcdir}"/default*.png ; do
+               size=${icon%.png}
+               size=${size##*/default}
+
+               if [[ ${size} -eq 48 ]] ; then
+                       newicon "${icon}" ${PN}.png
+               fi
+
+               newicon -s ${size} "${icon}" ${PN}.png
+       done
+
+       # Install menu
+       local app_name="Mozilla ${MOZ_PN^}"
+       local desktop_file="${FILESDIR}/icon/${PN}-r2.desktop"
+       local exec_command="${PN}"
+       local icon="${PN}"
+       local use_wayland="false"
+
+       if [[ -n ${MOZ_ESR} ]] ; then
+               local desktop_filename="${PN}-esr.desktop"
+       else
+               local desktop_filename="${PN}.desktop"
+       fi
+
+       if use wayland ; then
+               use_wayland="true"
+       fi
+
+       cp "${desktop_file}" "${WORKDIR}/${PN}.desktop-template" || die
+
+       sed -i \
+               -e "s:@NAME@:${app_name}:" \
+               -e "s:@EXEC@:${exec_command}:" \
+               -e "s:@ICON@:${icon}:" \
+               "${WORKDIR}/${PN}.desktop-template" || die
+
+       newmenu "${WORKDIR}/${PN}.desktop-template" "${desktop_filename}"
+
+       rm "${WORKDIR}/${PN}.desktop-template" || die
+
+       # Install wrapper script
+       [[ -f "${ED}/usr/bin/${PN}" ]] && rm "${ED}/usr/bin/${PN}"
+       newbin "${FILESDIR}/${PN}-r1.sh" ${PN}
+
+       # Update wrapper
+       sed -i \
+               -e "s:@PREFIX@:${EPREFIX}/usr:" \
+               -e "s:@DEFAULT_WAYLAND@:${use_wayland}:" \
+               "${ED}/usr/bin/${PN}" || die
+}
+
+pkg_postinst() {
+       xdg_pkg_postinst
+
+       optfeature_header "Optional programs for extra features:"
+       optfeature "desktop notifications" x11-libs/libnotify
+       optfeature "encrypted chat support" net-libs/libotr
+       optfeature "fallback mouse cursor theme e.g. on WMs" 
gnome-base/gsettings-desktop-schemas
+}

Reply via email to